/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
)

// checks if the RolloutStatus type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &RolloutStatus{}

// RolloutStatus struct for RolloutStatus
type RolloutStatus struct {
	Id *string `json:"id,omitempty"`
	RolloutId *string `json:"rollout_id,omitempty"`
	ChannelId *string `json:"channel_id,omitempty"`
	OrganizationId *string `json:"organization_id,omitempty"`
	InteractionId *string `json:"interaction_id,omitempty"`
	Interaction map[string]interface{} `json:"interaction,omitempty"`
	Version *int32 `json:"version,omitempty"`
	VersionMinor *int32 `json:"version_minor,omitempty"`
	State *string `json:"state,omitempty"`
	Errors *RolloutError `json:"errors,omitempty"`
	Main *bool `json:"main,omitempty"`
	CreatedAt *string `json:"created_at,omitempty"`
	UpdatedAt *string `json:"updated_at,omitempty"`
}

// NewRolloutStatus instantiates a new RolloutStatus object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewRolloutStatus() *RolloutStatus {
	this := RolloutStatus{}
	return &this
}

// NewRolloutStatusWithDefaults instantiates a new RolloutStatus object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewRolloutStatusWithDefaults() *RolloutStatus {
	this := RolloutStatus{}
	return &this
}

// GetId returns the Id field value if set, zero value otherwise.
func (o *RolloutStatus) GetId() string {
	if o == nil || IsNil(o.Id) {
		var ret string
		return ret
	}
	return *o.Id
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *RolloutStatus) GetIdOk() (*string, bool) {
	if o == nil || IsNil(o.Id) {
		return nil, false
	}
	return o.Id, true
}

// HasId returns a boolean if a field has been set.
func (o *RolloutStatus) HasId() bool {
	if o != nil && !IsNil(o.Id) {
		return true
	}

	return false
}

// SetId gets a reference to the given string and assigns it to the Id field.
func (o *RolloutStatus) SetId(v string) {
	o.Id = &v
}

// GetRolloutId returns the RolloutId field value if set, zero value otherwise.
func (o *RolloutStatus) GetRolloutId() string {
	if o == nil || IsNil(o.RolloutId) {
		var ret string
		return ret
	}
	return *o.RolloutId
}

// GetRolloutIdOk returns a tuple with the RolloutId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *RolloutStatus) GetRolloutIdOk() (*string, bool) {
	if o == nil || IsNil(o.RolloutId) {
		return nil, false
	}
	return o.RolloutId, true
}

// HasRolloutId returns a boolean if a field has been set.
func (o *RolloutStatus) HasRolloutId() bool {
	if o != nil && !IsNil(o.RolloutId) {
		return true
	}

	return false
}

// SetRolloutId gets a reference to the given string and assigns it to the RolloutId field.
func (o *RolloutStatus) SetRolloutId(v string) {
	o.RolloutId = &v
}

// GetChannelId returns the ChannelId field value if set, zero value otherwise.
func (o *RolloutStatus) GetChannelId() string {
	if o == nil || IsNil(o.ChannelId) {
		var ret string
		return ret
	}
	return *o.ChannelId
}

// GetChannelIdOk returns a tuple with the ChannelId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *RolloutStatus) GetChannelIdOk() (*string, bool) {
	if o == nil || IsNil(o.ChannelId) {
		return nil, false
	}
	return o.ChannelId, true
}

// HasChannelId returns a boolean if a field has been set.
func (o *RolloutStatus) HasChannelId() bool {
	if o != nil && !IsNil(o.ChannelId) {
		return true
	}

	return false
}

// SetChannelId gets a reference to the given string and assigns it to the ChannelId field.
func (o *RolloutStatus) SetChannelId(v string) {
	o.ChannelId = &v
}

// GetOrganizationId returns the OrganizationId field value if set, zero value otherwise.
func (o *RolloutStatus) GetOrganizationId() string {
	if o == nil || IsNil(o.OrganizationId) {
		var ret string
		return ret
	}
	return *o.OrganizationId
}

// GetOrganizationIdOk returns a tuple with the OrganizationId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *RolloutStatus) GetOrganizationIdOk() (*string, bool) {
	if o == nil || IsNil(o.OrganizationId) {
		return nil, false
	}
	return o.OrganizationId, true
}

// HasOrganizationId returns a boolean if a field has been set.
func (o *RolloutStatus) HasOrganizationId() bool {
	if o != nil && !IsNil(o.OrganizationId) {
		return true
	}

	return false
}

// SetOrganizationId gets a reference to the given string and assigns it to the OrganizationId field.
func (o *RolloutStatus) SetOrganizationId(v string) {
	o.OrganizationId = &v
}

// GetInteractionId returns the InteractionId field value if set, zero value otherwise.
func (o *RolloutStatus) GetInteractionId() string {
	if o == nil || IsNil(o.InteractionId) {
		var ret string
		return ret
	}
	return *o.InteractionId
}

// GetInteractionIdOk returns a tuple with the InteractionId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *RolloutStatus) GetInteractionIdOk() (*string, bool) {
	if o == nil || IsNil(o.InteractionId) {
		return nil, false
	}
	return o.InteractionId, true
}

// HasInteractionId returns a boolean if a field has been set.
func (o *RolloutStatus) HasInteractionId() bool {
	if o != nil && !IsNil(o.InteractionId) {
		return true
	}

	return false
}

// SetInteractionId gets a reference to the given string and assigns it to the InteractionId field.
func (o *RolloutStatus) SetInteractionId(v string) {
	o.InteractionId = &v
}

// GetInteraction returns the Interaction field value if set, zero value otherwise.
func (o *RolloutStatus) GetInteraction() map[string]interface{} {
	if o == nil || IsNil(o.Interaction) {
		var ret map[string]interface{}
		return ret
	}
	return o.Interaction
}

// GetInteractionOk returns a tuple with the Interaction field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *RolloutStatus) GetInteractionOk() (map[string]interface{}, bool) {
	if o == nil || IsNil(o.Interaction) {
		return map[string]interface{}{}, false
	}
	return o.Interaction, true
}

// HasInteraction returns a boolean if a field has been set.
func (o *RolloutStatus) HasInteraction() bool {
	if o != nil && !IsNil(o.Interaction) {
		return true
	}

	return false
}

// SetInteraction gets a reference to the given map[string]interface{} and assigns it to the Interaction field.
func (o *RolloutStatus) SetInteraction(v map[string]interface{}) {
	o.Interaction = v
}

// GetVersion returns the Version field value if set, zero value otherwise.
func (o *RolloutStatus) GetVersion() int32 {
	if o == nil || IsNil(o.Version) {
		var ret int32
		return ret
	}
	return *o.Version
}

// GetVersionOk returns a tuple with the Version field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *RolloutStatus) GetVersionOk() (*int32, bool) {
	if o == nil || IsNil(o.Version) {
		return nil, false
	}
	return o.Version, true
}

// HasVersion returns a boolean if a field has been set.
func (o *RolloutStatus) HasVersion() bool {
	if o != nil && !IsNil(o.Version) {
		return true
	}

	return false
}

// SetVersion gets a reference to the given int32 and assigns it to the Version field.
func (o *RolloutStatus) SetVersion(v int32) {
	o.Version = &v
}

// GetVersionMinor returns the VersionMinor field value if set, zero value otherwise.
func (o *RolloutStatus) GetVersionMinor() int32 {
	if o == nil || IsNil(o.VersionMinor) {
		var ret int32
		return ret
	}
	return *o.VersionMinor
}

// GetVersionMinorOk returns a tuple with the VersionMinor field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *RolloutStatus) GetVersionMinorOk() (*int32, bool) {
	if o == nil || IsNil(o.VersionMinor) {
		return nil, false
	}
	return o.VersionMinor, true
}

// HasVersionMinor returns a boolean if a field has been set.
func (o *RolloutStatus) HasVersionMinor() bool {
	if o != nil && !IsNil(o.VersionMinor) {
		return true
	}

	return false
}

// SetVersionMinor gets a reference to the given int32 and assigns it to the VersionMinor field.
func (o *RolloutStatus) SetVersionMinor(v int32) {
	o.VersionMinor = &v
}

// GetState returns the State field value if set, zero value otherwise.
func (o *RolloutStatus) GetState() string {
	if o == nil || IsNil(o.State) {
		var ret string
		return ret
	}
	return *o.State
}

// GetStateOk returns a tuple with the State field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *RolloutStatus) GetStateOk() (*string, bool) {
	if o == nil || IsNil(o.State) {
		return nil, false
	}
	return o.State, true
}

// HasState returns a boolean if a field has been set.
func (o *RolloutStatus) HasState() bool {
	if o != nil && !IsNil(o.State) {
		return true
	}

	return false
}

// SetState gets a reference to the given string and assigns it to the State field.
func (o *RolloutStatus) SetState(v string) {
	o.State = &v
}

// GetErrors returns the Errors field value if set, zero value otherwise.
func (o *RolloutStatus) GetErrors() RolloutError {
	if o == nil || IsNil(o.Errors) {
		var ret RolloutError
		return ret
	}
	return *o.Errors
}

// GetErrorsOk returns a tuple with the Errors field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *RolloutStatus) GetErrorsOk() (*RolloutError, bool) {
	if o == nil || IsNil(o.Errors) {
		return nil, false
	}
	return o.Errors, true
}

// HasErrors returns a boolean if a field has been set.
func (o *RolloutStatus) HasErrors() bool {
	if o != nil && !IsNil(o.Errors) {
		return true
	}

	return false
}

// SetErrors gets a reference to the given RolloutError and assigns it to the Errors field.
func (o *RolloutStatus) SetErrors(v RolloutError) {
	o.Errors = &v
}

// GetMain returns the Main field value if set, zero value otherwise.
func (o *RolloutStatus) GetMain() bool {
	if o == nil || IsNil(o.Main) {
		var ret bool
		return ret
	}
	return *o.Main
}

// GetMainOk returns a tuple with the Main field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *RolloutStatus) GetMainOk() (*bool, bool) {
	if o == nil || IsNil(o.Main) {
		return nil, false
	}
	return o.Main, true
}

// HasMain returns a boolean if a field has been set.
func (o *RolloutStatus) HasMain() bool {
	if o != nil && !IsNil(o.Main) {
		return true
	}

	return false
}

// SetMain gets a reference to the given bool and assigns it to the Main field.
func (o *RolloutStatus) SetMain(v bool) {
	o.Main = &v
}

// GetCreatedAt returns the CreatedAt field value if set, zero value otherwise.
func (o *RolloutStatus) GetCreatedAt() string {
	if o == nil || IsNil(o.CreatedAt) {
		var ret string
		return ret
	}
	return *o.CreatedAt
}

// GetCreatedAtOk returns a tuple with the CreatedAt field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *RolloutStatus) GetCreatedAtOk() (*string, bool) {
	if o == nil || IsNil(o.CreatedAt) {
		return nil, false
	}
	return o.CreatedAt, true
}

// HasCreatedAt returns a boolean if a field has been set.
func (o *RolloutStatus) HasCreatedAt() bool {
	if o != nil && !IsNil(o.CreatedAt) {
		return true
	}

	return false
}

// SetCreatedAt gets a reference to the given string and assigns it to the CreatedAt field.
func (o *RolloutStatus) SetCreatedAt(v string) {
	o.CreatedAt = &v
}

// GetUpdatedAt returns the UpdatedAt field value if set, zero value otherwise.
func (o *RolloutStatus) GetUpdatedAt() string {
	if o == nil || IsNil(o.UpdatedAt) {
		var ret string
		return ret
	}
	return *o.UpdatedAt
}

// GetUpdatedAtOk returns a tuple with the UpdatedAt field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *RolloutStatus) GetUpdatedAtOk() (*string, bool) {
	if o == nil || IsNil(o.UpdatedAt) {
		return nil, false
	}
	return o.UpdatedAt, true
}

// HasUpdatedAt returns a boolean if a field has been set.
func (o *RolloutStatus) HasUpdatedAt() bool {
	if o != nil && !IsNil(o.UpdatedAt) {
		return true
	}

	return false
}

// SetUpdatedAt gets a reference to the given string and assigns it to the UpdatedAt field.
func (o *RolloutStatus) SetUpdatedAt(v string) {
	o.UpdatedAt = &v
}

func (o RolloutStatus) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o RolloutStatus) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Id) {
		toSerialize["id"] = o.Id
	}
	if !IsNil(o.RolloutId) {
		toSerialize["rollout_id"] = o.RolloutId
	}
	if !IsNil(o.ChannelId) {
		toSerialize["channel_id"] = o.ChannelId
	}
	if !IsNil(o.OrganizationId) {
		toSerialize["organization_id"] = o.OrganizationId
	}
	if !IsNil(o.InteractionId) {
		toSerialize["interaction_id"] = o.InteractionId
	}
	if !IsNil(o.Interaction) {
		toSerialize["interaction"] = o.Interaction
	}
	if !IsNil(o.Version) {
		toSerialize["version"] = o.Version
	}
	if !IsNil(o.VersionMinor) {
		toSerialize["version_minor"] = o.VersionMinor
	}
	if !IsNil(o.State) {
		toSerialize["state"] = o.State
	}
	if !IsNil(o.Errors) {
		toSerialize["errors"] = o.Errors
	}
	if !IsNil(o.Main) {
		toSerialize["main"] = o.Main
	}
	if !IsNil(o.CreatedAt) {
		toSerialize["created_at"] = o.CreatedAt
	}
	if !IsNil(o.UpdatedAt) {
		toSerialize["updated_at"] = o.UpdatedAt
	}
	return toSerialize, nil
}

type NullableRolloutStatus struct {
	value *RolloutStatus
	isSet bool
}

func (v NullableRolloutStatus) Get() *RolloutStatus {
	return v.value
}

func (v *NullableRolloutStatus) Set(val *RolloutStatus) {
	v.value = val
	v.isSet = true
}

func (v NullableRolloutStatus) IsSet() bool {
	return v.isSet
}

func (v *NullableRolloutStatus) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableRolloutStatus(val *RolloutStatus) *NullableRolloutStatus {
	return &NullableRolloutStatus{value: val, isSet: true}
}

func (v NullableRolloutStatus) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableRolloutStatus) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


